import java.util.*;

class Fruit {}
class Banana extends Fruit {}
class Orange extends Fruit {}

public class Sample {
  public static void receiveFruit(Fruit fruit) {
    System.out.println("received " + fruit);
  }

  public static void receiveFruitBasket(List<Fruit> fruits) {
    System.out.println("received basket of " + fruits);
    fruits.add(new Orange());
  }

  public static void main(String[] args) {
    Banana banana = new Banana();
    Orange orange = new Orange();

    receiveFruit(banana);
    receiveFruit(orange);

    List<Fruit> fruits = new ArrayList<>();
    List<Banana> bananas = new ArrayList<>();
    List<Orange> oranges = new ArrayList<>();

    receiveFruitBasket(fruits);
    System.out.println(fruits);

    //receiveFruitBasket(bananas); //ERROR
    //receiveFruitBasket(oranges); //ERROR

    //Compiler won't allow this, it protects
    //us from accidentally putting an orange or something else into 
    //a basket of bananas.
  }
}

